package com.slodon.b2b2c.starter.mq.entity;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 *
 * 消息发送信息
 * @author wuxy
 */
@Data
public class MessageSendVO implements Serializable {

    private static final long serialVersionUID = 5946366651091755026L;
    //商户对应id或者会员对应id
    private long receiveId;
    //模版类型
    private String tplType;
    //跳转链接信息
    private String msgLinkInfo;
    //模版参数，从前往后对应，若无模板参数，则设置为空
    private String[] templateParam;
    //微信参数构造
    private List<MessageSendProperty> propertyList;

    public MessageSendVO(long receiveId, String tplType, String msgLinkInfo, String[] templateParam) {
        this.receiveId = receiveId;
        this.tplType = tplType;
        this.msgLinkInfo = msgLinkInfo;
        this.templateParam = templateParam;
    }

    public MessageSendVO(List<MessageSendProperty> propertyList, Integer receiveId, String tplType, String msgLinkInfo, String[] templateParam) {
        this.receiveId = receiveId;
        this.tplType = tplType;
        this.msgLinkInfo = msgLinkInfo;
        this.templateParam = templateParam;
        this.propertyList = propertyList;
    }

}
