package com.slodon.b2b2c.starter.entity.cpcn;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * 4611 绑定银行卡请求参数
 */
@Data
public class TxBindCardRequest implements Serializable {
    private static final long serialVersionUID = -1681476394518415845L;

    @ApiModelProperty(value = "机构编号", required = true)
    private String institutionId;
    @ApiModelProperty(value = "绑定流水号", required = true)
    private String bindingTxSn;
    @ApiModelProperty(value = "用户id", required = true)
    private String userId;
    @ApiModelProperty(value = "卡类型：10-借记账户，20=贷记账户", required = true)
    private String bankCardType = "10";
    @ApiModelProperty(value = "操作标识：10-绑卡，20-解绑，30-升级", required = true)
    private String operationFlag;
    @ApiModelProperty(value = "绑卡验证方式，10-短信验证，20-小额打款验证，30-静默绑卡，40一键绑卡", required = true)
    private String bindingWay;
    @ApiModelProperty(value = "证件类型：0=身份证，个人必填")
    private String credentialType = "0";
    @ApiModelProperty(value = "身份证号，个人必填")
    private String credentialNumber;
    @ApiModelProperty(value = "绑定银行ID-参考银行编码表", required = true)
    private String bankId;
    @ApiModelProperty(value = "账户类型：11-个人账户，12-企业账户", required = true)
    private String bankAccountType;
    @ApiModelProperty(value = "账户名称", required = true)
    private String bankAccountName;
    @ApiModelProperty(value = "账户号码", required = true)
    private String bankAccountNumber;
    @ApiModelProperty(value = "银行卡预留手机号,个人必填")
    private String bankPhoneNumber;
    @ApiModelProperty(value = "分支行名称,企业绑卡必填")
    private String branchName;
    @ApiModelProperty(value = "省份,企业绑卡必填")
    private String province;
    @ApiModelProperty(value = "城市,企业绑卡必填")
    private String city;
    @ApiModelProperty(value = "后台通知地址")
    private String noticeURL;
    @ApiModelProperty(value = "返回页面地址")
    private String pageURL;


}
