package com.slodon.b2b2c.starter.entity.cpcn;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 4600 上传商户资质信息 请求参数
 */
@Data
public class TxSellerQualificationRequest implements Serializable {
    private static final long serialVersionUID = -3008508496211397540L;
    @ApiModelProperty(value = "机构编号", required = true)
    private String institutionId;
    @ApiModelProperty(value = "流水号", required = true)
    private String txSn;
    @ApiModelProperty(value = "用户id，上传店铺id", required = true)
    private String userId;
    @ApiModelProperty(value = "资质信息", required = true)
    private List<QualificationImage> imageList = new ArrayList<>();

    /**
     * 资质图片信息
     */
    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class QualificationImage implements Serializable {
        private static final long serialVersionUID = -895955373107121780L;
        @ApiModelProperty(value = "图片流水号", required = true)
        private String itemNo;
        @ApiModelProperty(value = "图片类型，，10=身份证人像面，11=身份证国徽面，12=活体照片，13=经办人身份证正面，14=经办人身份证反面，" +
                "20=统一社会信用代码证，21=基本户开户证明，30=个体工商营业执照，40=用信凭证(新增)，" +
                "50=港澳居民来往内地通行证正面，51=港澳居民来往内地通行证反面，55=台湾居民来往大陆通行证正面，" +
                "56=台湾居民来往大陆通行证反面，60=外国护照正面，61=外国护照反面", required = true)
        private String imageType;
        @ApiModelProperty(value = "jpg、bmp、png格式，大小不超过1.8MB，图片 BASE64 编码", required = true)
        private String imageContent;
    }
}
