package com.slodon.b2b2c.starter.redisson.constant;

/**
 * 分布式锁名称常量
 */
public class LockKeyConst {

    /**
     * 修改库存的锁前缀，后接productId
     */
    public static final String PRODUCT_STOCK_PREFIX = "product_stock_lock_";
    /**
     * 修改会员资产的锁前缀（优惠券、积分、余额），后接memberId
     */
    public static final String MEMBER_ASSET_PREFIX = "member_asset_lock_";
    /**
     * 优惠券领取的锁前缀，后接couponId
     */
    public static final String COUPON_RECEIVE_PREFIX = "coupon_receive_lock_";
    /**
     * 会员签到的锁前缀，后接memberId
     */
    public static final String MEMBER_SIGN_PREFIX = "member_sign_lock_";
    /**
     * 会员登录的锁前缀，后接memberId
     */
    public static final String MEMBER_LOGIN_PREFIX = "member_login_lock_";
    /**
     * 会员抽奖的锁前缀，后接memberId
     */
    public static final String MEMBER_DRAW_PREFIX = "member_draw_lock_";
    /**
     * 会员提现的锁前缀，后接memberId
     */
    public static final String MEMBER_WITHDRAW_PREFIX = "member_withdraw_lock_";
}
