package com.slodon.bbc.starter.thirdParty.client;

import com.slodon.bbc.starter.thirdParty.entity.SlodonThirdPartyQrCodeRequest;
import org.springframework.data.redis.core.StringRedisTemplate;

import java.awt.image.BufferedImage;

/**
 * 第三方操作客户端
 */
public interface ThirdPartyBaseClient {
    /**
     * 获取二维码
     *
     * @param stringRedisTemplate redis操作工具
     * @param qrCodeRequest 业务参数
     * @return 二维码图片
     */
    BufferedImage getQrCode(StringRedisTemplate stringRedisTemplate, SlodonThirdPartyQrCodeRequest qrCodeRequest) throws Exception;
}
