package com.slodon.bbc.starter.thirdParty.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * 获取二维码请求参数
 *
 */
@Data
public class SlodonThirdPartyQrCodeRequest implements Serializable {

    private static final long serialVersionUID = -7394130189197173961L;

    @ApiModelProperty(value = "小程序来源 1、抖音 2、支付宝；3、百度；4、微信小程序", required = true)
    private Integer source;

    @ApiModelProperty(value = "扫描二维码后跳转的页面，不包含参数，前面不要加'/'", required = true)
    private String page;

    @ApiModelProperty(value = "二维码中携带的参数")
    private Map<String,Object> params = new LinkedHashMap<>();


    /**
     * 添加参数
     * @param key 键
     * @param value 值
     */
    public void addParam(String key,Object value){
        this.params.put(key,value);
    }
}
