/*
 * copyright
 * slodon
 * version-v4.1
 * date-2022-07-22
 */
package com.slodon.b2b2c.core.config;

import lombok.extern.slf4j.Slf4j;

/**
 * 生产环境配置文件，发布生产环境时将些文件内容覆盖DomainUrlUtil文件
 * DomainUrlUtil
 */
@Slf4j
public class DomainUrlUtil {
    /**
     * 主站的URL
     */
    public static final String SLD_API_URL = "/";
    /**
     * 静态资源的URL
     */
    public static final String SLD_STATIC_RESOURCES = "/api";
    /**
     * admin前端地址
     */
    public static final String SLD_ADMIN_URL = "http://54.46.9.88:81";

    /**
     * seller前端地址
     */
    public static final String SLD_SELLER_URL = "http://54.46.9.88:82";

    /**
     * 移动端前端地址
     */
    public static final String SLD_H5_URL = "/";
    /**
     * pc前端地址
     */
    public static final String SLD_PC_URL = "http://54.46.9.88";

    /**
     * minio图片资源的URL
     */
    public static final String SLD_IMAGE_RESOURCES = "https://xinke-xinke-s3-test.s3.ap-east-1.amazonaws.com/";

    /**
     * 七牛云图片资源的URL
     */
    public static final String QINIUYUN_IMAGE_RESOURCES = "";
    /**
     * 腾讯云图片资源的URL
     */
    public static final String TENCENTCLOUD_IMAGE_RESOURCES = "";
    /**
     * 阿里云图片资源的URL
     */
    public static final String ALIYUN_IMAGE_RESOURCES = "";

    /**
     * Elastic Search URL PORT
     */
    public static final String SLD_ES_URL = "54.46.9.88";
    public static final Integer SLD_ES_PORT = 9200;
    /**
     * Elastic Search 用户名 密码
     */
    public static final String SLD_ES_USERNAME = "elastic";
    public static final String SLD_ES_PASSWORD = "iN5aD0wI6cB2";
    /**
     * es索引名称
     */
    public static final String ES_INDEX_NAME = "gpb2b2c";
    /**
     * 积分商城es索引名称
     */
    public static final String INTEGRAL_ES_INDEX_NAME = "gpb2b2c_integral";

    /**
     * rabbitMq host 端口号 用户名 密码
     */
    public static final String SLD_MQ_HOST = "54.46.9.88";
    public static final Integer SLD_MQ_PORT = 5672;
    public static final String SLD_MQ_USERNAME = "admin";
    public static final String SLD_MQ_PASSWORD = "vH7vD8oK4lJ5";
    /**
     * rabbitMq 名称前缀（交换机、队列名称）
     */
    public static final String SLD_MQ_NAME_PREFIX = "xinke_test";

    /**
     * redis 数据库 host 端口 数据库
     */
    public static final Integer SLD_REDIS_DATABASE = 2;
    public static final String SLD_REDIS_HOST = "54.46.9.88";
    public static final Integer SLD_REDIS_PORT = 6379;
    public static final String SLD_REDIS_PASSWORD = "4CJdgVb4";

    /**
     * mysql读库 用户名 密码
     */
    public static final String SLD_MYSQL_READ_USERNAME = "dev";
    public static final String SLD_MYSQL_READ_PASSWORD = "kY7-yU2{uO9_";
    /**
     * mysql写库 用户名 密码
     */
    public static final String SLD_MYSQL_WRITE_USERNAME = "dev";
    public static final String SLD_MYSQL_WRITE_PASSWORD = "kY7-yU2{uO9_";

    /**
     * mongodb uri
     */
    public static final String SLD_MONGODB_URI = "mongodb://dev:oJ6mZ2fY6aL3fS8yO8wF@54.46.9.88:27017/b2b2c?authSource=b2b2c";

    /**
     * 上传图片类型，1-公共上传，2-七牛云上传，3-腾讯云上传，4-阿里云上传
     */
    public static final Integer UPLOAD_IMAGE_TYPE = 1;

    /**
     * 发送短信类型，1-腾讯云发送，2-云片发送，3-阿里云发送
     */
    public static final Integer SEND_SMS_TYPE = 1;

    /**
     * 数据清洗模式，1==清除模式，2==转义模式
     */
    public static final Integer XSS_MODE = 2;

    /**
     * 支付宝公钥证书路径
     */
    public static final String APP_CERT_PATH = "/root/alipay_cert/appCertPublicKey_2017112900241969.crt";
    public static final String ALIPAY_CERT_PATH = "/root/alipay_cert/alipayCertPublicKey_RSA2.crt";
    public static final String ALIPAY_ROOT_CERT_PATH = "/root/alipay_cert/alipayRootCert.crt";

    /**
     * 中金支付测试是否开启，1-开启，正式环境切换为其他值
     */
    public static final Integer ZJ_PAY_TEST = 1;

    /**
     * gp系统反向检测用户url
     */
    public static final String GP_SYSTEM_USER_INFO_API_URL = "https://uc.greenpass360.com/user-api/info/basic.html";

    /**
     * gp系统正向检测用户url
     */
    public static final String GP_SYSTEM_USER_NAME_PASSWORD_CHECK_API_URL = "https://uc.greenpass360.com/user-api/login/check.html";

    /**
     * gp系统aes key-我司
     */
    public static final String GP_SYSTEM_SSO_ASE_KEY = "BLqJoxZ8wjR2KknF";

    /**
     * gp系统aes key-客户
     */
    public static final String GP_SYSTEM_CUSTOMER_SSO_ASE_KEY = "Srg57Z4o6wK0Mrc7";

    /**
     * gp系统用户同步，默认密码
     */
    public static final String GP_SYSTEM_SSO_PASSWORD = "bxNVaKFQ1ep3jvkC";

    /**
     * 阿里云卖家端——注册注册短信code码
     */
    public static final String ALI_SMS_SELLER_REGISTER_CODE = "SMS_221075273";

    /**
     * 阿里云卖家端——忘记密码短信code码
     */
    public static final String ALI_SMS_SELLER_FORGET_CODE = "SMS_221045328";

    /**
     * 阿里云卖家端——商品违规下架短信code码
     */
    public static final String ALI_SMS_SELLER_GOODS_ILLEGAL_OFF_SHELF_CODE = "SMS_221045328";
}
