package com.slodon.b2b2c.core.constant;

/**
 * 支付常量
 */
public class PayConst {
    /**
     * 支付发起来源 pc-pc,mbrowser-移动设备浏览器,app-app,wxxcx-微信小程序,wxbrowser-微信内部浏览器
     */
    public final static String SOURCE_PC = "pc";
    public final static String SOURCE_MBROWSER = "mbrowser";
    public final static String SOURCE_APP = "app";
    public final static String SOURCE_WXXCX = "wxxcx";
    public final static String SOURCE_WXBROWSER = "wxbrowser";

    /**
     * 支付方式
     */
    public final static String METHOD_BALANCE = "balance";
    public final static String NAME_BALANCE = "余额支付";
    public final static String METHOD_WX = "wx";
    public final static String NAME_WX = "微信支付";
    public final static String METHOD_ALIPAY = "alipay";
    public final static String NAME_ALIPAY = "支付宝";
    public final static String METHOD_PAYPAL = "paypal";
    public final static String NAME_PAYPAL = "PayPal";
    public final static String METHOD_ZJ = "zj";
    public final static String METHOD_ZJ_WX = "zj_wx";
    public final static String METHOD_ZJ_ALI = "zj_ali";
    public final static String METHOD_ZJ_BANK = "zj_bank";
    public final static String NAME_BANK = "企业网银";

    /**
     * 余额支付类型
     */
    public final static String TYPE_BALANCE = "BALANCE";
    /**
     * 微信支付类型 NATIVE-原生扫码,APP-App支付,JSAPI-公众号支付,MINIAPP-小程序支付,MWEB-H5支付
     */
    public final static String WX_TYPE_NATIVE = "NATIVE";
    public final static String WX_TYPE_APP = "APP";
    public final static String WX_TYPE_JSAPI = "JSAPI";
    public final static String WX_TYPE_MWEB = "MWEB";
    public final static String WX_TYPE_MINIAPP = "MINIAPP";

    /**
     * 支付宝支付类型 NATIVE-原生扫码,APP-App支付,MWEB-H5支付
     */
    public final static String ALI_TYPE_NATIVE = "NATIVE";
    public final static String ALI_TYPE_APP = "APP";
    public final static String ALI_TYPE_MWEB = "MWEB";

    /**
     * PayPal支付类型 NATIVE-原生扫码,APP-App支付,MWEB-H5支付
     */
    public final static String PAYPAL_TYPE_NATIVE = "NATIVE";
    public final static String PAYPAL_TYPE_APP = "APP";
    public final static String PAYPAL_TYPE_MWEB = "MWEB";

    /**
     * 微信支付类型 NATIVE-原生扫码,APP-App支付,JSAPI-公众号支付，MINIAPP-小程序支付,MWEB-H5支付
     */
    public final static String ZJ_TYPE_NATIVE = "NATIVE";
    public final static String ZJ_TYPE_APP = "APP";
    public final static String ZJ_TYPE_JSAPI = "JSAPI";
    public final static String ZJ_TYPE_MWEB = "MWEB";
    public final static String ZJ_TYPE_MINIAPP = "MINIAPP";

    /**
     * 中金支付类型10-快捷支付，20-网银支付，42-扫码支付(微信，支付宝，银联，聚合)，80-跳转支付(目前只有微信小程序)
     */
    public final static String ZJ_TYPE_20 = "20";
    public final static String ZJ_TYPE_42 = "42";
    public final static String ZJ_TYPE_80 = "80";

    /**
     * 中金条码支付类型:10=微信，20=支付宝
     */
    public final static String ZJ_QR_TYPE_WX = "10";
    public final static String ZJ_QR_TYPE_ALI = "20";

}
