package com.slodon.b2b2c.business.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;

/**
 * 订单支付流水号表，用于中金支付，生成新的流水号之前，要关闭所有支付中的支付订单example
 */
@Data
public class PayTxExample implements Serializable {
    private static final long serialVersionUID = 2808157779418030762L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer txIdNotEquals;

    /**
     * 用于批量操作
     */
    private String txIdIn;

    /**
     * 流水id
     */
    private Integer txId;

    /**
     * 流水号
     */
    private String txSn;

    /**
     * 流水号,用于模糊查询
     */
    private String txSnLike;

    /**
     * 订单号
     */
    private String paySn;

    /**
     * 订单号,用于模糊查询
     */
    private String paySnLike;

    /**
     * 状态，1-支付中，2-已关闭，3-支付成功
     */
    private Integer state;

    /**
     * stateIn，用于批量操作
     */
    private String stateIn;

    /**
     * stateNotIn，用于批量操作
     */
    private String stateNotIn;

    /**
     * stateNotEquals，用于批量操作
     */
    private Integer stateNotEquals;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照txId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}