package com.slodon.b2b2c.goods.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 榜单分类example
 */
@Data
public class GoodsRankCategoryExample implements Serializable {
    private static final long serialVersionUID = -7279024960014520964L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer categoryIdNotEquals;

    /**
     * 用于批量操作
     */
    private String categoryIdIn;

    /**
     * 分类id
     */
    private Integer categoryId;

    /**
     * 分类名称
     */
    private String categoryName;

    /**
     * 分类名称,用于模糊查询
     */
    private String categoryNameLike;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 启用状态：0-未启用；1-启用；默认是1
     */
    private Integer state;

    /**
     * stateIn，用于批量操作
     */
    private String stateIn;

    /**
     * stateNotIn，用于批量操作
     */
    private String stateNotIn;

    /**
     * stateNotEquals，用于批量操作
     */
    private Integer stateNotEquals;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 创建人id
     */
    private Integer createAdminId;

    /**
     * 大于等于开始时间
     */
    private Date updateTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date updateTimeBefore;

    /**
     * 更新人id
     */
    private Integer updateAdminId;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照categoryId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;

    /**
     * 正在使用的标识
     */
    private String inUse;

}