package com.slodon.b2b2c.member.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author cyan
 */
@Data
public class MemberEnquiryExample implements Serializable {
    private static final long serialVersionUID = -3320183787038395718L;

    /**
     * 用户uid
     */
    private Integer createUid;

    /**
     * 多字段模糊查询
     */
    private String keyword;

    /**
     * 姓名模糊查询
     */
    private String nameLike;

    /**
     * 邮箱模糊查询
     */
    private String emailLike;

    /**
     * 询盘类型查询
     */
    private String itemType;

    /**
     * 询盘类型in查询
     */
    private String itemTypeIn;

    /**
     * 状态等于查询
     */
    private String statusEqual;

    /**
     * 状态不等于查询
     */
    private String statusNotEqual;

    /**
     * 创建时间小于等于查询
     */
    private String createTimeLte;

    /**
     * 状态大于等于查询
     */
    private String createTimeGte;

    /**
     * 渠道  1-海外站；2-国内站
     */
    private String channel;

    /**
     * 店铺Id查询
     */
    private Long storeId;

    /**
     * 询盘有效性查询
     */
    private Integer validStatus;

    /**
     * 排序条件，条件之间用逗号隔开
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}