package com.slodon.b2b2c.member.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 会员提现申请
 */
@Data
public class MemberApplyCash implements Serializable {
    private static final long serialVersionUID = 7000724593786444438L;

    @ApiModelProperty("提现ID")
    private Integer cashId;

    @ApiModelProperty("会员ID")
    private Integer memberId;

    @ApiModelProperty("会员名称")
    private String memberName;

    @ApiModelProperty("提现单号")
    private String cashSn;

    @ApiModelProperty("提现金额")
    private BigDecimal cashAmount;

    @ApiModelProperty("申请时间")
    private Date applyTime;

    @ApiModelProperty("审核时间")
    private Date auditTime;

    @ApiModelProperty("完成时间")
    private Date finishTime;

    @ApiModelProperty("付款账号")
    private String payAccount;

    @ApiModelProperty("收款银行")
    private String receiveBank;

    @ApiModelProperty("收款账号")
    private String receiveAccount;

    @ApiModelProperty("收款人姓名")
    private String receiveName;

    @ApiModelProperty("收款方式：UNIONPAY-银行、WXPAY-微信、ALIPAY-支付宝")
    private String receiveType;

    @ApiModelProperty("状态：1、待处理；2、提现成功；3、已拒绝；4、提现失败")
    private Integer state;

    @ApiModelProperty("拒绝原因")
    private String refuseReason;

    @ApiModelProperty("提现失败原因")
    private String failReason;

    @ApiModelProperty("操作管理员ID")
    private Integer adminId;

    @ApiModelProperty("操作管理员名称")
    private String adminName;

    @ApiModelProperty("手续费")
    private BigDecimal serviceFee;

    @ApiModelProperty("交易流水号")
    private String transactionSn;

    @ApiModelProperty("微信类型：APP-app；JSAPI-公众号；MINIAPP-小程序")
    private String wxType;
}