package com.slodon.b2b2c.promotion.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 抽奖记录表example
 */
@Data
public class DrawRecordExample implements Serializable {
    private static final long serialVersionUID = 4964752692679513077L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer recordIdNotEquals;

    /**
     * 用于批量操作
     */
    private String recordIdIn;

    /**
     * 抽奖记录id
     */
    private Integer recordId;

    /**
     * 抽奖活动id
     */
    private Integer drawId;

    /**
     * 奖项id
     */
    private Integer prizeId;

    /**
     * 奖项名称
     */
    private String prizeName;

    /**
     * 奖项名称,用于模糊查询
     */
    private String prizeNameLike;

    /**
     * 会员id
     */
    private Integer memberId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员名称,用于模糊查询
     */
    private String memberNameLike;

    /**
     * 是否中奖，0-未中奖，1-中奖
     */
    private Integer isPrize;

    /**
     * 大于等于开始时间
     */
    private Date recordTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date recordTimeBefore;

    /**
     * 抽奖消耗积分数
     */
    private Integer useIntegral;

    /**
     * 奖品类型，1-积分，2-优惠券，中奖必填
     */
    private Integer prizeType;

    /**
     * 奖励描述（未中奖、xx积分、xxx优惠券*n）
     */
    private String description;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照recordId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}