package com.slodon.b2b2c.seller.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * 4611 绑定银行卡请求参数
 */
@Data
public class SellerBindCardDTO implements Serializable {
    private static final long serialVersionUID = -1681476394518415845L;

    @ApiModelProperty(value = "身份证号，个人必填")
    private String credentialNumber;
    @ApiModelProperty(value = "绑定银行ID-参考银行编码表", required = true)
    private String bankId;
    @ApiModelProperty(value = "绑卡-银行名称，对应中金附录", required = true)
    private String bankName;
    @ApiModelProperty(value = "账户类型：11-个人账户，12-企业账户", required = true)
    private String bankAccountType;
    @ApiModelProperty(value = "账户名称", required = true)
    private String bankAccountName;
    @ApiModelProperty(value = "账户号码", required = true)
    private String bankAccountNumber;
    @ApiModelProperty(value = "银行卡预留手机号,个人必填")
    private String bankPhoneNumber;
    @ApiModelProperty(value = "分支行名称,企业绑卡必填")
    private String branchName;
    @ApiModelProperty(value = "省份,企业绑卡必填")
    private String province;
    @ApiModelProperty(value = "城市,企业绑卡必填")
    private String city;
    @ApiModelProperty(value = "省份名称,企业绑卡必填")
    private String provinceName;
    @ApiModelProperty(value = "城市名称,企业绑卡必填")
    private String cityName;
}
