package com.slodon.b2b2c.seller.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 店铺绑定快递公司表example
 */
@Data
public class StoreBindExpressExample implements Serializable {
    private static final long serialVersionUID = -7570703954915331262L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer bindIdNotEquals;

    /**
     * 用于批量操作
     */
    private String bindIdIn;

    /**
     * 绑定ID
     */
    private Integer bindId;

    /**
     * 店铺ID
     */
    private Long storeId;

    /**
     * 快递公司ID
     */
    private Integer expressId;

    /**
     * 公司名称
     */
    private String expressName;

    /**
     * 公司名称,用于模糊查询
     */
    private String expressNameLike;

    /**
     * 快递公司状态，平台是否启用：1-启用，0-不启用
     */
    private Integer expressState;

    /**
     * expressStateIn，用于批量操作
     */
    private String expressStateIn;

    /**
     * expressStateNotIn，用于批量操作
     */
    private String expressStateNotIn;

    /**
     * expressStateNotEquals，用于批量操作
     */
    private Integer expressStateNotEquals;

    /**
     * 物流编号
     */
    private String expressCode;

    /**
     * 公司网址
     */
    private String expressWebsite;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 支付类型 1 现付 2 到付 3 月结 4 第三方支付(仅顺丰支持)
     */
    private Integer payType;

    /**
     * 客户帐号(对应快递100的partnerId)
     */
    private String customerName;

    /**
     * 客户帐号(对应快递100的partnerId),用于模糊查询
     */
    private String customerNameLike;

    /**
     * 客户密码(对应快递100的partnerKey)
     */
    private String customerPwd;

    /**
     * 所属网点(对应快递100的net)
     */
    private String sendSite;

    /**
     * 网点信息(对应快递100的checkMan)
     */
    private String sendStaff;

    /**
     * 月结号
     */
    private String monthCode;

    /**
     * 电子面单模板大小,参考快递鸟模板样式表(非必填)
     */
    private String templateSize;

    /**
     * 模板id(快递100专用)
     */
    private String templateId;

    /**
     * 电子面单客户账户名称
     */
    private String partnerName;

    /**
     * 电子面单客户账户名称,用于模糊查询
     */
    private String partnerNameLike;

    /**
     * 电子面单承载编号
     */
    private String code;

    /**
     * 产品类型
     */
    private String expType;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照bindId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}