package com.slodon.b2b2c.seller.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;

/**
 * 店铺快递配置表example
 */
@Data
public class StoreExpressSettingExample implements Serializable {
    private static final long serialVersionUID = 6173669598287171112L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer settingIdNotEquals;

    /**
     * 用于批量操作
     */
    private String settingIdIn;

    /**
     * 配置ID
     */
    private Integer settingId;

    /**
     * 店铺ID
     */
    private Long storeId;

    /**
     * 快递鸟电商ID
     */
    private String businessId;

    /**
     * 加密私钥
     */
    private String appKey;

    /**
     * 打印机名称
     */
    private String printerName;

    /**
     * 打印机名称,用于模糊查询
     */
    private String printerNameLike;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照settingId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}