package com.slodon.b2b2c.seller.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
public class StoreLabelBindGoodsExample implements Serializable {
    private static final long serialVersionUID = 7107280040568445185L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer bindIdNotEquals;

    /**
     * 用于批量操作
     */
    private String bindIdIn;

    /**
     * 绑定id
     */
    private Integer bindId;

    /**
     * 父分类ID
     */
    private Integer parentInnerLabelId;

    /**
     * 店铺内部分类ID
     */
    private Integer innerLabelId;

    /**
     * 店铺内部分类路径
     */
    private String innerLabelPath;

    /**
     * 商品ID
     */
    private Long goodsId;

    /**
     * 店铺ID
     */
    private Long storeId;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 创建人ID
     */
    private Long createVendorId;

    /**
     * 创建人名字
     */
    private String createVendorName;

    /**
     * 创建人名字,用于模糊查询
     */
    private String createVendorNameLike;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照bindId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}