package com.slodon.b2b2c.seller.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 店铺绑定快递公司表
 */
@Data
public class StoreBindExpress implements Serializable {
    private static final long serialVersionUID = 293534488905934863L;

    @ApiModelProperty("绑定ID")
    private Integer bindId;

    @ApiModelProperty("店铺ID")
    private Long storeId;

    @ApiModelProperty("快递公司ID")
    private Integer expressId;

    @ApiModelProperty("公司名称")
    private String expressName;

    @ApiModelProperty("快递公司状态，平台是否启用：1-启用，0-不启用")
    private Integer expressState;

    @ApiModelProperty("物流编号")
    private String expressCode;

    @ApiModelProperty("公司网址")
    private String expressWebsite;

    @ApiModelProperty("添加时间")
    private Date createTime;

    @ApiModelProperty("支付类型 1 现付 2 到付 3 月结 4 第三方支付(仅顺丰支持)")
    private Integer payType;

    @ApiModelProperty("客户帐号(对应快递100的partnerId)")
    private String customerName;

    @ApiModelProperty("客户密码(对应快递100的partnerKey)")
    private String customerPwd;

    @ApiModelProperty("所属网点(对应快递100的net)")
    private String sendSite;

    @ApiModelProperty("网点信息(对应快递100的checkMan)")
    private String sendStaff;

    @ApiModelProperty("月结号")
    private String monthCode;

    @ApiModelProperty("电子面单模板大小,参考快递鸟模板样式表(非必填)")
    private String templateSize;

    @ApiModelProperty("模板id(快递100专用)")
    private String templateId;

    @ApiModelProperty("电子面单客户账户名称")
    private String partnerName;

    @ApiModelProperty("电子面单承载编号")
    private String code;

    @ApiModelProperty("产品类型")
    private String expType;
}