package com.slodon.b2b2c.seller.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * 商户中金开户表，第一次绑卡成功写入数据
 */
@Data
public class StoreOpenAccount implements Serializable {
    private static final long serialVersionUID = -1768447320522439606L;

    @ApiModelProperty("进度id")
    private Integer openAccountId;

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("开户类型，11-个人，12-企业")
    private String userType;

    @ApiModelProperty("开户状态，10-绑卡成功待开户，20开户成功，21-开户失败，22-开户处理中")
    private Integer state;

    @ApiModelProperty("绑卡流水号")
    private String bindCardSn;

    @ApiModelProperty("影印件采集流水号")
    private String imageCollectionSn;

    @ApiModelProperty("开户流水号")
    private String openAccountSn;

    @ApiModelProperty("失败原因")
    private String failReason;

    @ApiModelProperty("绑卡-账户名称")
    private String bankAccountName;

    @ApiModelProperty("绑卡-账户号码")
    private String bankAccountNumber;

    @ApiModelProperty("绑卡-银行id，对应中金附录")
    private String bankId;

    @ApiModelProperty("绑卡-银行名称，对应中金附录")
    private String bankName;

    @ApiModelProperty("绑卡-个人-身份证号")
    private String credentialNumber;

    @ApiModelProperty("绑卡-个人-银行预留手机号")
    private String bankPhoneNumber;

    @ApiModelProperty("绑卡-企业-分支行名称")
    private String branchName;

    @ApiModelProperty("绑卡-企业-银行省份编码，对应中金附录")
    private String province;

    @ApiModelProperty("绑卡-企业-银行省份名称，对应中金附录")
    private String provinceName;

    @ApiModelProperty("绑卡-企业-银行城市编码，对应中金附录")
    private String city;

    @ApiModelProperty("绑卡-企业-银行城市名称，对应中金附录")
    private String cityName;

    @ApiModelProperty("开户-个人-用户姓名")
    private String pUserName;

    @ApiModelProperty("开户-个人-用户手机号码")
    private String pPhoneNumber;

    @ApiModelProperty("开户-个人-证件号码")
    private String pCredentialNumber;

    @ApiModelProperty("开户-个人-身份证件有效期（起始）,yyyyMMdd")
    private String pIssDate;

    @ApiModelProperty("开户-个人-身份证件有效期（到期）,当证件长期有效时为99991231")
    private String pExpiryDate;

    @ApiModelProperty("开户-个人-联系地址")
    private String pIndAddress;

    @ApiModelProperty("开户-个人-个人邮箱")
    private String pIndEmail;

    @ApiModelProperty("开户-个人-身份证正面扫描件")
    private String pIndCardUp;

    @ApiModelProperty("开户-个人-身份证背面扫描件")
    private String pIndCardDown;

    @ApiModelProperty("开户-企业-企业名称,工商登记企业名称")
    private String eCorporationName;

    @ApiModelProperty("开户-企业-分类类别,营业执照企业类型为“合伙企业”时必填。详见附录")
    private String eCategoryType;

    @ApiModelProperty("开户-企业-分类类别名称,营业执照企业类型为“合伙企业”时必填。详见附录")
    private String eCategoryTypeName;

    @ApiModelProperty("开户-企业-统一社会信用代码")
    private String eUnifiedSocialCreditCode;

    @ApiModelProperty("开户-企业-企业邮箱")
    private String eCorEmail;

    @ApiModelProperty("开户-企业-企业地址")
    private String eCorAddress;

    @ApiModelProperty("开户-企业-省份,详见附录")
    private String eProvince;

    @ApiModelProperty("开户-企业-省份名称,详见附录")
    private String eProvinceName;

    @ApiModelProperty("开户-企业-城市,详见附录")
    private String eCity;

    @ApiModelProperty("开户-企业-城市名称,详见附录")
    private String eCityName;

    @ApiModelProperty("开户-企业-区/县,详见附录")
    private String eDistrict;

    @ApiModelProperty("开户-企业-区/县名称,详见附录")
    private String eDistrictName;

    @ApiModelProperty("开户-企业-企业规模：01=大型;02=中型;03=小型;04=微型;98=其他")
    private String eScale;

    @ApiModelProperty("开户-企业-企业规模名称：01=大型;02=中型;03=小型;04=微型;98=其他")
    private String eScaleName;

    @ApiModelProperty("开户-企业-企业银行账户")
    private String eBasicAcctNo;

    @ApiModelProperty("开户-企业-基础存款账户编号")
    private String eApprovalNo;

    @ApiModelProperty("开户-企业-营业执照有效期（起始）,yyyyMMdd格式")
    private String eAllLicenceIssDate;

    @ApiModelProperty("开户-企业-营业执照有效期（到期），格式：yyyyMMdd；证件长期有效时为 99991231")
    private String eAllLicenceExpiryDate;

    @ApiModelProperty("开户-企业-法人姓名")
    private String eLegalPersonName;

    @ApiModelProperty("开户-企业-法人证件号码")
    private String eLegalCredentialNumber;

    @ApiModelProperty("开户-企业-法人身份证件有效期（起始）,格式：yyyyMMdd")
    private String eLegalPersonIssDate;

    @ApiModelProperty("开户-企业-法人身份证件有效期（到期）,当证件长期有效时为99991231")
    private String eLegalPersonExpiryDate;

    @ApiModelProperty("开户-企业-法人联系电话")
    private String eLegalPersonContactNumber;

    @ApiModelProperty("开户-企业-营业执照扫描件")
    private String eBusinessLicenseImage;

    @ApiModelProperty("开户-企业-基本开户证明")
    private String eOpenAccountCertificate;

    @ApiModelProperty("开户-企业-法人身份证正面扫描件")
    private String eLegalCardUp;

    @ApiModelProperty("开户-企业-法人身份证背面扫描件")
    private String eLegalCardDown;
}