package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 商品分类统计查询类基类
 */
@Data
public class CategoryBaseExample implements Serializable {

    private static final long serialVersionUID = -7318058537903511164L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 商品分类id，一级分类
     */
    private Integer categoryId;

    /**
     * 用于批量操作
     */
    private String categoryIdIn;

    /**
     * 商品分类名称
     */
    private String categoryName;

    /**
     * 商品分类名称,用于模糊查询
     */
    private String categoryNameLike;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 销售额
     */
    private BigDecimal saleAmount;

    /**
     * 销量
     */
    private Integer saleNum;

    /**
     * 退单数
     */
    private Integer returnNum;

    /**
     * 退单sku件数
     */
    private Integer returnProductNum;

    /**
     * 退单金额
     */
    private BigDecimal returnAmount;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
