package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 商品统计查询类基类
 */
@Data
public class GoodsBaseExample implements Serializable {

    private static final long serialVersionUID = -3119451741848440638L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 商品id
     */
    private Long goodsId;

    /**
     * 用于批量操作
     */
    private String goodsIdIn;

    /**
     * 商品名称
     */
    private String goodsName;

    /**
     * 商品名称,用于模糊查询
     */
    private String goodsNameLike;

    /**
     * 商品图片
     */
    private String goodsImage;

    /**
     * 访客数
     */
    private Integer visitorNum;

    /**
     * 浏览量
     */
    private Integer viewNum;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 销售额
     */
    private BigDecimal saleAmount;

    /**
     * 销量
     */
    private Integer saleNum;

    /**
     * 被收藏数
     */
    private Integer collectionNum;

    /**
     * 加购人数
     */
    private Integer addCartMemberNum;

    /**
     * 品牌id
     */
    private Integer brandId;

    /**
     * 品牌名称
     */
    private String brandName;

    /**
     * 品牌名称,用于模糊查询
     */
    private String brandNameLike;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 店铺名称
     */
    private String storeName;

    /**
     * 店铺名称,用于模糊查询
     */
    private String storeNameLike;

    /**
     * 商品分类id
     */
    private Integer goodsCategoryId1;

    /**
     * 商品分类名称
     */
    private String goodsCategoryName1;

    /**
     * 商品分类名称,用于模糊查询
     */
    private String goodsCategoryName1Like;

    /**
     * 商品价格
     */
    private BigDecimal goodsPrice;

    /**
     * 退单数
     */
    private Integer returnNum;

    /**
     * 退单sku件数
     */
    private Integer returnProductNum;

    /**
     * 退单金额
     */
    private BigDecimal returnAmount;

    /**
     * 下单人数
     */
    private Integer orderSubmitMemberNum;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
