package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 会员统计查询类基类
 */
@Data
public class MemberBaseExample implements Serializable {

    private static final long serialVersionUID = -2931911329466603663L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 会员id
     */
    private Integer memberId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员名称,用于模糊查询
     */
    private String memberNameLike;

    /**
     * 大于等于开始时间
     */
    private Date registerTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date registerTimeBefore;

    /**
     * 充值金额
     */
    private BigDecimal rechargeAmount;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 支付订单金额
     */
    private BigDecimal orderPayAmount;

    /**
     * 退单数
     */
    private Integer returnNum;

    /**
     * 退单金额
     */
    private BigDecimal returnAmount;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
