package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 省份统计查询类基类
 */
@Data
public class ProvinceBaseExample implements Serializable {

    private static final long serialVersionUID = 3987692207252336945L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 省份名称
     */
    private String provinceName;

    /**
     * 省份名称,用于模糊查询
     */
    private String provinceNameLike;

    /**
     * 省份编码
     */
    private String provinceCode;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 下单人数
     */
    private Integer orderSubmitMemberNum;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 支付订单金额
     */
    private BigDecimal orderPayAmount;

    /**
     * 支付订单人数
     */
    private Integer orderPayMemberNum;

    /**
     * 新增会员数
     */
    private Integer newMemberNum;

    /**
     * 新增店铺数
     */
    private Integer newStoreNum;

    /**
     * 活跃会员数
     */
    private Integer activeMemberNum;

    /**
     * 退单数
     */
    private Integer returnNum;

    /**
     * 退单金额
     */
    private BigDecimal returnAmount;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
