package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 店铺统计查询类基类
 */
@Data
public class StoreBaseExample implements Serializable {

    private static final long serialVersionUID = -2671696725512898500L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 店铺名称
     */
    private String storeName;

    /**
     * 店铺名称,用于模糊查询
     */
    private String storeNameLike;

    /**
     * 访客数
     */
    private Integer visitorNum;

    /**
     * 浏览量
     */
    private Integer viewNum;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 下单人数
     */
    private Integer orderSubmitMemberNum;

    /**
     * 下单客单价，下单金额/下单人数
     */
    private BigDecimal orderSubmitAtv;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 支付订单金额
     */
    private BigDecimal orderPayAmount;

    /**
     * 支付订单人数
     */
    private Integer orderPayMemberNum;

    /**
     * 支付订单客单价，支付订单金额/支付订单人数
     */
    private BigDecimal orderPayAtv;

    /**
     * 访问-下单转化率，下单人数/访客数*100%
     */
    private String pvSubmitRate;

    /**
     * 访问-支付转化率，支付订单人数/访客数*100%
     */
    private String pvPayRate;

    /**
     * 下单-支付转化率，支付订单人数/下单人数*100%
     */
    private String submitPayRate;

    /**
     * 商品访客数
     */
    private Integer goodsVisitorNum;

    /**
     * 商品浏览量
     */
    private Integer goodsViewNum;

    /**
     * 被访问商品数
     */
    private Integer viewGoodsNum;

    /**
     * 被访问商品数,用于模糊查询
     */
    private String viewGoodsNumLike;

    /**
     * 新增商品数
     */
    private Integer newGoodsNum;

    /**
     * 新增商品数,用于模糊查询
     */
    private String newGoodsNumLike;

    /**
     * 被收藏商品数
     */
    private Integer collectionGoodsNum;

    /**
     * 被收藏商品数,用于模糊查询
     */
    private String collectionGoodsNumLike;

    /**
     * 店铺关注数
     */
    private Integer collectionStoreNum;

    /**
     * 动销商品数
     */
    private Integer salingGoodsNum;

    /**
     * 动销商品数,用于模糊查询
     */
    private String salingGoodsNumLike;

    /**
     * 退单数
     */
    private Integer returnNum;

    /**
     * 退单金额
     */
    private BigDecimal returnAmount;

    /**
     * 新增用户数
     */
    private Integer newMemberNum;

    /**
     * 人均浏览量
     */
    private BigDecimal perViewNum;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
