package com.slodon.b2b2c.statistics.example.base;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 终端统计查询类基类
 */
@Data
public class TerminalBaseExample implements Serializable {

    private static final long serialVersionUID = -4832598171261425976L;
    /**
     * 用于编辑时的重复判断
     */
    private Long statsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String statsIdIn;

    /**
     * 统计id
     */
    private Long statsId;

    /**
     * 大于等于开始时间
     */
    private Date statsTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date statsTimeBefore;

    /**
     * 终端名称，1、pc；2、H5；3、Android；4、IOS；5、微信小程序
     */
    private String terminalName;

    /**
     * 终端名称，1、pc；2、H5；3、Android；4、IOS；5、微信小程序,用于模糊查询
     */
    private String terminalNameLike;

    /**
     * 终端编码，1、pc；2、H5；3、Android；4、IOS；5、微信小程序
     */
    private String terminalCode;

    /**
     * 用于批量操作
     */
    private String terminalCodeIn;

    /**
     * 访客数
     */
    private Integer visitorNum;

    /**
     * 新访客数
     */
    private Integer newVisitorNum;

    /**
     * 浏览量
     */
    private Integer viewNum;

    /**
     * 下单数
     */
    private Integer orderSubmitNum;

    /**
     * 下单金额
     */
    private BigDecimal orderSubmitAmount;

    /**
     * 下单人数
     */
    private Integer orderSubmitMemberNum;

    /**
     * 下单客单价，下单金额/下单人数
     */
    private BigDecimal orderSubmitAtv;

    /**
     * 支付订单数
     */
    private Integer orderPayNum;

    /**
     * 支付订单金额
     */
    private BigDecimal orderPayAmount;

    /**
     * 支付订单人数
     */
    private Integer orderPayMemberNum;

    /**
     * 支付订单客单价，支付订单金额/支付订单人数
     */
    private BigDecimal orderPayAtv;

    /**
     * 访问-下单转化率，下单人数/访客数*100%
     */
    private String pvSubmitRate;

    /**
     * 访问-支付转化率，支付订单人数/访客数*100%
     */
    private String pvPayRate;

    /**
     * 下单-支付转化率，支付订单人数/下单人数*100%
     */
    private String submitPayRate;

    /**
     * 新增会员数
     */
    private Integer newMemberNum;

    /**
     * 储值会员数
     */
    private Integer rechargeMemberNum;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照statsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}
