package com.slodon.b2b2c.statistics.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 用户行为统计表
 */
@Data
public class MemberBehavior implements Serializable {
    private static final long serialVersionUID = -4140180150148752400L;

    @ApiModelProperty("会员id")
    private Integer memberId;

    @ApiModelProperty("ip地址")
    private String ip;

    @ApiModelProperty("经纬度,经度纬度用英文逗号分隔")
    private String location;

    @ApiModelProperty("行为类型，gpv-商品浏览，cart-加入购物车，buy-购买，fav-商品收藏，spv-店铺浏览，reg-会员注册，pv-网站浏览，fol-店铺关注")
    private String behaviorType;

    @ApiModelProperty("商品id")
    private Long goodsId;

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("终端名称，pc-pc；h5-H5；android-Android；ios-IOS；xcx-微信小程序；bdxcx-百度小程序；alixcx-支付宝小程序；dyxcx-抖音小程序")
    private String source;

    @ApiModelProperty("页面url")
    private String pageUrl;

    @ApiModelProperty("上一个页面url")
    private String referrerPageUrl;

    @ApiModelProperty("设备类型，1-pc，2-移动设备，3-其他")
    private Integer equipmentType;

    @ApiModelProperty("设备识别码")
    private String uuid;

    @ApiModelProperty("访问时间")
    private Date behaviorTime;

    @ApiModelProperty("省份名称")
    private String provinceName;

    @ApiModelProperty("省份编码")
    private String provinceCode;

    @ApiModelProperty("城市名称")
    private String cityName;

    @ApiModelProperty("城市编码")
    private String cityCode;
}