package com.slodon.b2b2c.statistics.pojo.base;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 品牌统计基类
 */
@Data
public class BrandBase implements Serializable {
    private static final long serialVersionUID = 4398630918397694819L;
    @ApiModelProperty("统计id")
    private Long statsId;

    @ApiModelProperty("统计时间，数据统计的开始时间")
    private Date statsTime;

    @ApiModelProperty("品牌id")
    private Integer brandId;

    @ApiModelProperty("品牌名称")
    private String brandName;

    @ApiModelProperty("下单数")
    private Integer orderSubmitNum;

    @ApiModelProperty("下单金额")
    private BigDecimal orderSubmitAmount;

    @ApiModelProperty("支付订单数")
    private Integer orderPayNum;

    @ApiModelProperty("销售额")
    private BigDecimal saleAmount;

    @ApiModelProperty("销量")
    private Integer saleNum;

    @ApiModelProperty("退单数")
    private Integer returnNum;

    @ApiModelProperty("退单sku件数")
    private Integer returnProductNum;

    @ApiModelProperty("退单金额")
    private BigDecimal returnAmount;

    public void copy(BrandBase brandBase){
        BeanUtils.copyProperties(brandBase,this);
    }
}
