package com.slodon.b2b2c.statistics.pojo.base;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 会员统计基类
 */
@Data
public class MemberBase  implements Serializable {

    private static final long serialVersionUID = 730490527360992912L;
    @ApiModelProperty("统计id")
    private Long statsId;

    @ApiModelProperty("统计时间，数据统计的开始时间")
    private Date statsTime;

    @ApiModelProperty("会员id")
    private Integer memberId;

    @ApiModelProperty("会员名称")
    private String memberName;

    @ApiModelProperty("注册时间")
    private Date registerTime;

    @ApiModelProperty("充值金额")
    private BigDecimal rechargeAmount;

    @ApiModelProperty("下单数")
    private Integer orderSubmitNum;

    @ApiModelProperty("下单金额")
    private BigDecimal orderSubmitAmount;

    @ApiModelProperty("支付订单数")
    private Integer orderPayNum;

    @ApiModelProperty("支付订单金额")
    private BigDecimal orderPayAmount;

    @ApiModelProperty("退单数")
    private Integer returnNum;

    @ApiModelProperty("退单金额")
    private BigDecimal returnAmount;

    public void copy(MemberBase memberBase){
        BeanUtils.copyProperties(memberBase,this);
    }
}
