package com.slodon.b2b2c.statistics.pojo.base;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 省份统计基类
 */
@Data
public class ProvinceBase implements Serializable {

    private static final long serialVersionUID = -7147065368221207392L;
    @ApiModelProperty("统计id")
    private Long statsId;

    @ApiModelProperty("统计时间，数据统计的开始时间")
    private Date statsTime;

    @ApiModelProperty("省份名称")
    private String provinceName;

    @ApiModelProperty("省份编码")
    private String provinceCode;

    @ApiModelProperty("下单数")
    private Integer orderSubmitNum;

    @ApiModelProperty("下单金额")
    private BigDecimal orderSubmitAmount;

    @ApiModelProperty("下单人数")
    private Integer orderSubmitMemberNum;

    @ApiModelProperty("支付订单数")
    private Integer orderPayNum;

    @ApiModelProperty("支付订单金额")
    private BigDecimal orderPayAmount;

    @ApiModelProperty("支付订单人数")
    private Integer orderPayMemberNum;

    @ApiModelProperty("新增会员数")
    private Integer newMemberNum;

    @ApiModelProperty("新增店铺数")
    private Integer newStoreNum;

    @ApiModelProperty("活跃会员数")
    private Integer activeMemberNum;

    @ApiModelProperty("退单数")
    private Integer returnNum;

    @ApiModelProperty("退单金额")
    private BigDecimal returnAmount;

    public void copy(ProvinceBase provinceBase){
        BeanUtils.copyProperties(provinceBase,this);
    }
}
