package com.slodon.b2b2c.system.example;


import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 结算-中金商户订单分账表example
 */
@Data
public class BillOrderSplitExample implements Serializable {
    private static final long serialVersionUID = -6697843751379790238L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer splitIdNotEquals;

    /**
     * 用于批量操作
     */
    private String splitIdIn;

    /**
     * 分账id
     */
    private Integer splitId;

    /**
     * 订单号
     */
    private String orderSn;

    /**
     * 订单号,用于模糊查询
     */
    private String orderSnLike;

    /**
     * 结算单号
     */
    private String billSn;

    /**
     * 结算单号,用于模糊查询
     */
    private String billSnLike;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 分账流水号
     */
    private String txSn;

    /**
     * 分账流水号,用于模糊查询
     */
    private String txSnLike;

    /**
     * 分账金额
     */
    private BigDecimal splitAmount;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照splitId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}