package com.slodon.b2b2c.system.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 结算转账记录表example
 */
@Data
public class BillTransferExample implements Serializable {
    private static final long serialVersionUID = -8097395479448668634L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer transferIdNotEquals;

    /**
     * 用于批量操作
     */
    private String transferIdIn;

    /**
     * 转账id
     */
    private Integer transferId;

    /**
     * 结算单号
     */
    private String billSn;

    /**
     * 结算单号,用于模糊查询
     */
    private String billSnLike;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 转账流水号
     */
    private String txSn;

    /**
     * 转账流水号,用于模糊查询
     */
    private String txSnLike;

    /**
     * 转账金额
     */
    private BigDecimal transferAmount;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照transferId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}