package com.slodon.b2b2c.system.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;

/**
 * 银行表，用于中金网银支付example
 */
@Data
public class ZjBankExample implements Serializable {
    private static final long serialVersionUID = 1278053012895908677L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer bankIdNotEquals;

    /**
     * 用于批量操作
     */
    private String bankIdIn;

    /**
     * 主键id
     */
    private Integer bankId;

    /**
     * 银行编码，对于中金支付
     */
    private String bankCode;

    /**
     * 银行名称，对于中金支付
     */
    private String bankName;

    /**
     * 银行名称，对于中金支付,用于模糊查询
     */
    private String bankNameLike;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照bankId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}