package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 作者表example
 */
@Data
public class AuthorExample implements Serializable {
    private static final long serialVersionUID = 4928814489912555392L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer authorIdNotEquals;

    /**
     * 用于批量操作
     */
    private String authorIdIn;

    /**
     * 作者id
     */
    private Integer authorId;

    /**
     * 会员id
     */
    private Integer memberId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员名称,用于模糊查询
     */
    private String memberNameLike;

    /**
     * 会员昵称
     */
    private String memberNickname;

    /**
     * 会员昵称,用于模糊查询
     */
    private String memberNicknameLike;

    /**
     * 会员头像
     */
    private String memberAvatar;

    /**
     * 背景图片
     */
    private String backgroundImage;

    /**
     * 简介
     */
    private String introduction;

    /**
     * 角色:1会员，2商家
     */
    private Integer roleType;

    /**
     * 短视频发布权限状态：0-默认，1-待审核，2-审核通过(正常发布)，3-审核拒绝，4-禁止发布
     */
    private Integer permissionState;

    /**
     * permissionStateIn，用于批量操作
     */
    private String permissionStateIn;

    /**
     * permissionStateNotIn，用于批量操作
     */
    private String permissionStateNotIn;

    /**
     * permissionStateNotEquals，用于批量操作
     */
    private Integer permissionStateNotEquals;

    /**
     * 短视频拒绝理由,禁止理由
     */
    private String remark;

    /**
     * 直播状态，1-正常；0-禁止
     */
    private Integer liveState;

    /**
     * liveStateIn，用于批量操作
     */
    private String liveStateIn;

    /**
     * liveStateNotIn，用于批量操作
     */
    private String liveStateNotIn;

    /**
     * liveStateNotEquals，用于批量操作
     */
    private Integer liveStateNotEquals;

    /**
     * 直播禁止理由
     */
    private String forbidReason;

    /**
     * 直播禁止理由,用于模糊查询
     */
    private String forbidReasonLike;

    /**
     * 关注数
     */
    private Integer followNum;

    /**
     * 粉丝数
     */
    private Integer fansNum;

    /**
     * 粉丝数,用于模糊查询
     */
    private String fansNumLike;

    /**
     * 获赞总数
     */
    private Integer likeNum;

    /**
     * 绑定视频数
     */
    private Integer videoNum;

    /**
     * 绑定商品数
     */
    private Integer goodsNum;

    /**
     * 绑定商品数,用于模糊查询
     */
    private String goodsNumLike;

    /**
     * 点赞视频数
     */
    private Integer likeVideoNum;

    /**
     * 直播次数
     */
    private Integer liveNum;

    /**
     * 会员等级
     */
    private Integer grade;

    /**
     * 会员积分
     */
    private Integer integral;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 店铺名称
     */
    private String storeName;

    /**
     * 店铺名称,用于模糊查询
     */
    private String storeNameLike;

    /**
     * 店铺账号id
     */
    private Long vendorId;

    /**
     * 店铺账号
     */
    private String vendorName;

    /**
     * 店铺账号,用于模糊查询
     */
    private String vendorNameLike;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 大于等于开始时间
     */
    private Date updateTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date updateTimeBefore;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照authorId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;

    /**
     * 用于会员姓名和会员昵称模糊查询
     */
    private String keyword;
}