package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;

/**
 * 作者关注表example
 */
@Data
public class AuthorFollowExample implements Serializable {
    private static final long serialVersionUID = 804752674458966932L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer followIdNotEquals;

    /**
     * 用于批量操作
     */
    private String followIdIn;

    /**
     * followId
     */
    private Integer followId;

    /**
     * 作者id
     */
    private Integer fromAuthorId;

    /**
     * 作者id
     */
    private Integer toAuthorId;

    /**
     * 类型1:from关注to。2to关注from，3互相关注
     */
    private Integer type;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照followId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;

    /**
     * 类型1:关注。2粉丝
     */
    private Integer followType;

    /**
     * 作者id
     */
    private Integer authorId;

    /**
     * 用于处理互相关注作者id不为空标识（fromAuthorId和toAuthorId合用）
     */
    private String queryAuthorId;

    /**
     * 查询关注时是否关注不为空标识（fromAuthorId和toAuthorId合用）
     */
    private String queryIsFollow;
}