package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 店铺直播绑定会员表example
 */
@Data
public class LiveStoreBindMemberExample implements Serializable {
    private static final long serialVersionUID = 5780302963095948342L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer bindIdNotEquals;

    /**
     * 用于批量操作
     */
    private String bindIdIn;

    /**
     * 绑定id
     */
    private Integer bindId;

    /**
     * 会员id
     */
    private Integer memberId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员名称,用于模糊查询
     */
    private String memberNameLike;

    /**
     * 会员昵称
     */
    private String memberNickName;

    /**
     * 会员昵称,用于模糊查询
     */
    private String memberNickNameLike;

    /**
     * 会员手机号
     */
    private String memberMobile;

    /**
     * 会员手机号,用于模糊查询
     */
    private String memberMobileLike;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 店铺名称
     */
    private String storeName;

    /**
     * 店铺名称,用于模糊查询
     */
    private String storeNameLike;

    /**
     * 创建商户id
     */
    private Long createVendorId;

    /**
     * 创建商户名称
     */
    private String createVendorName;

    /**
     * 创建商户名称,用于模糊查询
     */
    private String createVendorNameLike;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照bindId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;

    /**
     * 店铺id
     */
    private Long storeIdNotEquals;

}