package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频评论表example
 */
@Data
public class SvideoCommentExample implements Serializable {
    private static final long serialVersionUID = -3201962683836204057L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer commentIdNotEquals;

    /**
     * 用于批量操作
     */
    private String commentIdIn;

    /**
     * 评论id
     */
    private Integer commentId;

    /**
     * 视频id
     */
    private Integer videoId;

    /**
     * 封面图地址
     */
    private String videoImage;

    /**
     * 评论人id
     */
    private Integer fromAuthorId;

    /**
     * 评论人名称
     */
    private String fromAuthorName;

    /**
     * 评论人名称,用于模糊查询
     */
    private String fromAuthorNameLike;

    /**
     * 评论人头像
     */
    private String memberAvatar;

    /**
     * 被回复人id
     */
    private Integer toAuthorId;

    /**
     * 被回复人名称
     */
    private String toAuthorName;

    /**
     * 被回复人名称,用于模糊查询
     */
    private String toAuthorNameLike;

    /**
     * 点赞数
     */
    private Integer likeNum;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 是否已读：0未读，1已读
     */
    private Integer isRead;

    /**
     * 评论内容
     */
    private String content;

    /**
     * 评论内容,用于模糊查询
     */
    private String contentLike;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照commentId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}