package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频标签表example
 */
@Data
public class SvideoLabelExample implements Serializable {
    private static final long serialVersionUID = 8287173190456190383L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer labelIdNotEquals;

    /**
     * 用于批量操作
     */
    private String labelIdIn;

    /**
     * 标签id
     */
    private Integer labelId;

    /**
     * 标签名称
     */
    private String labelName;

    /**
     * 标签名称,用于模糊查询
     */
    private String labelNameLike;

    /**
     * 排序0-255，0是最靠前
     */
    private Integer sort;

    /**
     * 是否显示:0不显示，1显示
     */
    private Integer isShow;

    /**
     * 绑定视频数量
     */
    private Integer videoNum;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 大于等于开始时间
     */
    private Date updateTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date updateTimeBefore;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照labelId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}