package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频回复表example
 */
@Data
public class SvideoReplyExample implements Serializable {
    private static final long serialVersionUID = 732610069933295488L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer replyIdNotEquals;

    /**
     * 用于批量操作
     */
    private String replyIdIn;

    /**
     * 回复id
     */
    private Integer replyId;

    /**
     * 父级回复id
     */
    private Integer parentReplyId;

    /**
     * 评论id
     */
    private Integer commentId;

    /**
     * 回复人id
     */
    private Integer fromAuthorId;

    /**
     * 回复人名称
     */
    private String fromAuthorName;

    /**
     * 回复人名称,用于模糊查询
     */
    private String fromAuthorNameLike;

    /**
     * 回复人头像
     */
    private String memberAvatar;

    /**
     * 被回复人id
     */
    private Integer toAuthorId;

    /**
     * 被回复人名称
     */
    private String toAuthorName;

    /**
     * 被回复人名称,用于模糊查询
     */
    private String toAuthorNameLike;

    /**
     * 点赞数
     */
    private Integer likeNum;

    /**
     * 视频id
     */
    private Integer videoId;

    /**
     * 封面图地址
     */
    private String videoImage;

    /**
     * 是否已读：0未读，1已读
     */
    private Integer isRead;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 回复内容
     */
    private String content;

    /**
     * 回复内容,用于模糊查询
     */
    private String contentLike;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照replyId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}