package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;

/**
 * 短视频主题视频表example
 */
@Data
public class SvideoThemeVideoExample implements Serializable {
    private static final long serialVersionUID = 1379275733855176451L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer themeVideoIdNotEquals;

    /**
     * 用于批量操作
     */
    private String themeVideoIdIn;

    /**
     * 主题视频id
     */
    private Integer themeVideoId;

    /**
     * 主题id
     */
    private Integer themeId;

    /**
     * 视频id
     */
    private Integer videoId;

    /**
     * 视频名称
     */
    private String videoName;

    /**
     * 视频名称,用于模糊查询
     */
    private String videoNameLike;

    /**
     * 封面图地址
     */
    private String videoImage;

    /**
     * 视频地址
     */
    private String videoPath;

    /**
     * 视频简介
     */
    private String introduction;

    /**
     * 视频类型:1-视频;2-图文
     */
    private Integer videoType;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照themeVideoId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}