package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频表example
 */
@Data
public class SvideoVideoExample implements Serializable {
    private static final long serialVersionUID = 592883443965433454L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer videoIdNotEquals;

    /**
     * 用于批量操作
     */
    private String videoIdIn;

    /**
     * 视频id
     */
    private Integer videoId;

    /**
     * 视频名称
     */
    private String videoName;

    /**
     * 视频名称,用于模糊查询
     */
    private String videoNameLike;

    /**
     * 视频地址
     */
    private String videoPath;

    /**
     * 封面图地址
     */
    private String videoImage;

    /**
     * 主题封面地址
     */
    private String videoThemeImage;

    /**
     * 视频简介
     */
    private String introduction;

    /**
     * 作者id
     */
    private Integer authorId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员名称,用于模糊查询
     */
    private String memberNameLike;

    /**
     * 会员昵称
     */
    private String memberNickname;

    /**
     * 会员昵称,用于模糊查询
     */
    private String memberNicknameLike;

    /**
     * 会员头像
     */
    private String memberAvatar;

    /**
     * 点赞数
     */
    private Integer likeNum;

    /**
     * 评论数
     */
    private Integer commentNum;

    /**
     * 分享数
     */
    private Integer shareNum;

    /**
     * 商品数
     */
    private Integer goodsNum;

    /**
     * 商品数,用于模糊查询
     */
    private String goodsNumLike;

    /**
     * 点击数
     */
    private Integer clickNum;

    /**
     * 标签id
     */
    private Integer labelId;

    /**
     * 标签名称
     */
    private String labelName;

    /**
     * 标签名称,用于模糊查询
     */
    private String labelNameLike;

    /**
     * 删除;0不删除，1伪删除
     */
    private Integer isDelete;

    /**
     * 状态:1待审核，2正常，3拒绝，4禁止显示，5删除
     */
    private Integer state;

    /**
     * stateIn，用于批量操作
     */
    private String stateIn;

    /**
     * stateNotIn，用于批量操作
     */
    private String stateNotIn;

    /**
     * stateNotEquals，用于批量操作
     */
    private Integer stateNotEquals;

    /**
     * 禁止理由,拒绝理由
     */
    private String remark;

    /**
     * 大于等于开始时间
     */
    private Date createTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date createTimeBefore;

    /**
     * 大于等于开始时间
     */
    private Date updateTimeAfter;

    /**
     * 小于等于结束时间
     */
    private Date updateTimeBefore;

    /**
     * 视频类型:1-视频;2-图文
     */
    private Integer videoType;

    /**
     * 正文内容
     */
    private String videoContent;

    /**
     * 正文内容,用于模糊查询
     */
    private String videoContentLike;

    /**
     * 图片信息(json存储)
     */
    private String imageInfo;

    /**
     * 宽度
     */
    private Integer width;

    /**
     * 高度
     */
    private Integer height;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照videoId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;

    /**
     * 用于视频名称和视频简介模糊查询
     */
    private String keyword;
}