package com.slodon.b2b2c.video.example;

import com.slodon.b2b2c.core.response.PagerInfo;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 短视频或直播商品表example
 */
@Data
public class VideoGoodsExample implements Serializable {
    private static final long serialVersionUID = 5439793420438499190L;

    /**
     * 用于编辑时的重复判断
     */
    private Integer videoGoodsIdNotEquals;

    /**
     * 用于批量操作
     */
    private String videoGoodsIdIn;

    /**
     * 视频商品id
     */
    private Integer videoGoodsId;

    /**
     * 视频id
     */
    private Integer videoId;

    /**
     * 视频类型：1-短视频；2-直播
     */
    private Integer videoType;

    /**
     * 作者id
     */
    private Integer authorId;

    /**
     * 商品id
     */
    private Long goodsId;

    /**
     * 用于批量操作
     */
    private String goodsIdIn;

    /**
     * 商品名称
     */
    private String goodsName;

    /**
     * 商品名称,用于模糊查询
     */
    private String goodsNameLike;

    /**
     * 商品广告语
     */
    private String goodsBrief;

    /**
     * 商品价格
     */
    private BigDecimal goodsPrice;

    /**
     * 商品图片
     */
    private String goodsImage;

    /**
     * 默认货品id
     */
    private Long defaultProductId;

    /**
     * 被查看次数
     */
    private Integer clickNum;

    /**
     * 排序条件，条件之间用逗号隔开，如果不传则按照videoGoodsId倒序排列
     */
    private String orderBy;

    /**
     * 分组条件
     */
    private String groupBy;

    /**
     * 分页信息
     */
    private PagerInfo pager;
}