package com.slodon.b2b2c.video.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 作者表
 */
@Data
public class Author implements Serializable {
    private static final long serialVersionUID = 1696358582946544744L;

    @ApiModelProperty("作者id")
    private Integer authorId;

    @ApiModelProperty("会员id")
    private Integer memberId;

    @ApiModelProperty("会员名称")
    private String memberName;

    @ApiModelProperty("会员昵称")
    private String memberNickname;

    @ApiModelProperty("会员头像")
    private String memberAvatar;

    @ApiModelProperty("背景图片")
    private String backgroundImage;

    @ApiModelProperty("简介")
    private String introduction;

    @ApiModelProperty("角色:1会员，2商家")
    private Integer roleType;

    @ApiModelProperty("短视频发布权限状态：0-默认，1-待审核，2-审核通过(正常发布)，3-审核拒绝，4-禁止发布")
    private Integer permissionState;

    @ApiModelProperty("短视频拒绝理由,禁止理由")
    private String remark;

    @ApiModelProperty("直播状态，1-正常；0-禁止")
    private Integer liveState;

    @ApiModelProperty("直播禁止理由")
    private String forbidReason;

    @ApiModelProperty("关注数")
    private Integer followNum;

    @ApiModelProperty("粉丝数")
    private Integer fansNum;

    @ApiModelProperty("获赞总数")
    private Integer likeNum;

    @ApiModelProperty("绑定视频数")
    private Integer videoNum;

    @ApiModelProperty("绑定商品数")
    private Integer goodsNum;

    @ApiModelProperty("点赞视频数")
    private Integer likeVideoNum;

    @ApiModelProperty("直播次数")
    private Integer liveNum;

    @ApiModelProperty("会员等级")
    private Integer grade;

    @ApiModelProperty("会员积分")
    private Integer integral;

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("店铺名称")
    private String storeName;

    @ApiModelProperty("店铺账号id")
    private Long vendorId;

    @ApiModelProperty("店铺账号")
    private String vendorName;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;
}