package com.slodon.b2b2c.video.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频评论表
 */
@Data
public class SvideoComment implements Serializable {
    private static final long serialVersionUID = -8256334906203132726L;

    @ApiModelProperty("评论id")
    private Integer commentId;

    @ApiModelProperty("视频id")
    private Integer videoId;

    @ApiModelProperty("封面图地址")
    private String videoImage;

    @ApiModelProperty("评论人id")
    private Integer fromAuthorId;

    @ApiModelProperty("评论人名称")
    private String fromAuthorName;

    @ApiModelProperty("评论人头像")
    private String memberAvatar;

    @ApiModelProperty("被回复人id")
    private Integer toAuthorId;

    @ApiModelProperty("被回复人名称")
    private String toAuthorName;

    @ApiModelProperty("点赞数")
    private Integer likeNum;

    @ApiModelProperty("评论时间")
    private Date createTime;

    @ApiModelProperty("是否已读：0未读，1已读")
    private Integer isRead;

    @ApiModelProperty("评论内容")
    private String content;

    @ApiModelProperty("是否自己的评论")
    private Boolean isSelf = true;

    @ApiModelProperty("是否点赞")
    private Boolean isLike = false;
}