package com.slodon.b2b2c.video.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频回复表
 */
@Data
public class SvideoReply implements Serializable {
    private static final long serialVersionUID = -3395647561590878464L;

    @ApiModelProperty("回复id")
    private Integer replyId;

    @ApiModelProperty("父级回复id")
    private Integer parentReplyId;

    @ApiModelProperty("评论id")
    private Integer commentId;

    @ApiModelProperty("回复人id")
    private Integer fromAuthorId;

    @ApiModelProperty("回复人名称")
    private String fromAuthorName;

    @ApiModelProperty("回复人头像")
    private String memberAvatar;

    @ApiModelProperty("被回复人id")
    private Integer toAuthorId;

    @ApiModelProperty("被回复人名称")
    private String toAuthorName;

    @ApiModelProperty("点赞数")
    private Integer likeNum;

    @ApiModelProperty("视频id")
    private Integer videoId;

    @ApiModelProperty("封面图地址")
    private String videoImage;

    @ApiModelProperty("是否已读：0未读，1已读")
    private Integer isRead;

    @ApiModelProperty("回复时间")
    private Date createTime;

    @ApiModelProperty("回复内容")
    private String content;

    @ApiModelProperty("是否自己的回复")
    private Boolean isSelf = true;

    @ApiModelProperty("是否点赞")
    private Boolean isLike = false;
}