package com.slodon.b2b2c.video.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 短视频表
 */
@Data
public class SvideoVideo implements Serializable {
    private static final long serialVersionUID = 3684584605066430142L;

    @ApiModelProperty("视频id")
    private Integer videoId;

    @ApiModelProperty("视频名称")
    private String videoName;

    @ApiModelProperty("视频地址")
    private String videoPath;

    @ApiModelProperty("封面图地址")
    private String videoImage;

    @ApiModelProperty("主题封面地址")
    private String videoThemeImage;

    @ApiModelProperty("视频简介")
    private String introduction;

    @ApiModelProperty("作者id")
    private Integer authorId;

    @ApiModelProperty("会员名称")
    private String memberName;

    @ApiModelProperty("会员昵称")
    private String memberNickname;

    @ApiModelProperty("会员头像")
    private String memberAvatar;

    @ApiModelProperty("点赞数")
    private Integer likeNum;

    @ApiModelProperty("评论数")
    private Integer commentNum;

    @ApiModelProperty("分享数")
    private Integer shareNum;

    @ApiModelProperty("商品数")
    private Integer goodsNum;

    @ApiModelProperty("点击数")
    private Integer clickNum;

    @ApiModelProperty("标签id")
    private Integer labelId;

    @ApiModelProperty("标签名称")
    private String labelName;

    @ApiModelProperty("删除;0不删除，1伪删除")
    private Integer isDelete;

    @ApiModelProperty("状态:1待审核，2正常，3拒绝，4禁止显示，5删除")
    private Integer state;

    @ApiModelProperty("禁止理由,拒绝理由")
    private String remark;

    @ApiModelProperty("创建时间(发布时间)")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("视频类型:1-视频;2-图文")
    private Integer videoType;

    @ApiModelProperty("正文内容")
    private String videoContent;

    @ApiModelProperty("图片信息(json存储)")
    private String imageInfo;

    @ApiModelProperty("宽度")
    private Integer width;

    @ApiModelProperty("高度")
    private Integer height;
}