package com.slodon.b2b2c.video.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 短视频或直播商品表
 */
@Data
public class VideoGoods implements Serializable {
    private static final long serialVersionUID = -8813182732302468233L;

    @ApiModelProperty("视频商品id")
    private Integer videoGoodsId;

    @ApiModelProperty("视频id")
    private Integer videoId;

    @ApiModelProperty("视频类型：1-短视频；2-直播")
    private Integer videoType;

    @ApiModelProperty("作者id")
    private Integer authorId;

    @ApiModelProperty("商品id")
    private Long goodsId;

    @ApiModelProperty("商品名称")
    private String goodsName;

    @ApiModelProperty("商品广告语")
    private String goodsBrief;

    @ApiModelProperty("商品价格")
    private BigDecimal goodsPrice;

    @ApiModelProperty("商品图片")
    private String goodsImage;

    @ApiModelProperty("默认货品id")
    private Long defaultProductId;

    @ApiModelProperty("被查看次数")
    private Integer clickNum;
}