package com.slodon.b2b2c.dao.read.goods;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.goods.dto.GoodsRankListDTO;
import com.slodon.b2b2c.goods.example.GoodsBindRankExample;
import com.slodon.b2b2c.goods.pojo.GoodsBindRank;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 榜单与商品绑定关系表readDao
 */
public interface GoodsBindRankReadMapper extends BaseReadMapper<GoodsBindRank, GoodsBindRankExample> {

    /**
     * 根据条件获取榜单商品排名列表
     *
     * @param example 查询条件信息
     * @return
     */
    List<GoodsRankListDTO> getGoodsRankList(@Param("example") GoodsBindRankExample example);
}