package com.slodon.b2b2c.dao.read.statistics;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.statistics.example.CategoryDayExample;
import com.slodon.b2b2c.statistics.pojo.CategoryDay;
import com.slodon.b2b2c.statistics.pojo.base.CategoryBase;
import com.slodon.b2b2c.vo.statistics.SalesTrendVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 商品分类日统计表readDao
 */
public interface CategoryDayReadMapper extends BaseReadMapper<CategoryDay, CategoryDayExample> {

    /**
     * 查询符合条件的分组记录数
     *
     * @param example
     * @return
     */
    Integer getCategoryCount(@Param("example") CategoryDayExample example);

    /**
     * 商品分类统计
     *
     * @param example
     * @param startRow
     * @param size
     * @return
     */
    List<CategoryBase> getCategoryList(@Param("example") CategoryDayExample example,
                                       @Param("startRow") Integer startRow,
                                       @Param("size") Integer size);

    /**
     * 商品分类销售变化趋势
     *
     * @param example
     * @return
     */
    List<SalesTrendVO> getCategoryTrendList(@Param("example") CategoryDayExample example);
}