package com.slodon.b2b2c.dao.read.statistics;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.statistics.example.MemberDayExample;
import com.slodon.b2b2c.statistics.pojo.MemberDay;
import com.slodon.b2b2c.statistics.pojo.base.MemberBase;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 会员日统计表readDao
 */
public interface MemberDayReadMapper extends BaseReadMapper<MemberDay, MemberDayExample> {

    /**
     * 查询符合条件的分组记录数
     *
     * @param example
     * @return
     */
    Integer getMemberCount(@Param("example") MemberDayExample example);

    /**
     * 会员统计
     *
     * @param example
     * @param startRow
     * @param size
     * @return
     */
    List<MemberBase> getMemberList(@Param("example") MemberDayExample example,
                                   @Param("startRow") Integer startRow,
                                   @Param("size") Integer size);
}