package com.slodon.b2b2c.dao.read.statistics;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.statistics.example.MemberStoreDayExample;
import com.slodon.b2b2c.statistics.pojo.MemberStoreDay;
import com.slodon.b2b2c.statistics.pojo.base.MemberStoreBase;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 店铺会员日统计表readDao
 */
public interface MemberStoreDayReadMapper extends BaseReadMapper<MemberStoreDay, MemberStoreDayExample> {

    /**
     * 查询符合条件的分组记录数
     *
     * @param example
     * @return
     */
    Integer getMemberStoreCount(@Param("example") MemberStoreDayExample example);

    /**
     * 店铺会员统计
     *
     * @param example
     * @param startRow
     * @param size
     * @return
     */
    List<MemberStoreBase> getMemberStoreList(@Param("example") MemberStoreDayExample example,
                                             @Param("startRow") Integer startRow,
                                             @Param("size") Integer size);
}