package com.slodon.b2b2c.dao.read.statistics;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.statistics.example.ProvinceDayExample;
import com.slodon.b2b2c.statistics.pojo.ProvinceDay;
import com.slodon.b2b2c.statistics.pojo.base.ProvinceBase;
import com.slodon.b2b2c.vo.statistics.SalesTrendVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 省份日统计表readDao
 */
public interface ProvinceDayReadMapper extends BaseReadMapper<ProvinceDay, ProvinceDayExample> {

    /**
     * 省份统计
     *
     * @param example
     * @return
     */
    List<ProvinceBase> getProvinceList(@Param("example") ProvinceDayExample example);

    /**
     * 各省份销售变化趋势
     *
     * @param example
     * @return
     */
    List<SalesTrendVO> getProvinceTrendList(@Param("example") ProvinceDayExample example);

    /**
     * 各省份销售占比
     *
     * @param example
     * @return
     */
    List<ProvinceBase> getProvincePercentList(@Param("example") ProvinceDayExample example);
}