package com.slodon.b2b2c.dao.read.statistics;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.statistics.example.StoreDayExample;
import com.slodon.b2b2c.statistics.pojo.StoreDay;
import com.slodon.b2b2c.statistics.pojo.base.StoreBase;
import com.slodon.b2b2c.vo.statistics.MovableGoodsVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 店铺日统计表readDao
 */
public interface StoreDayReadMapper extends BaseReadMapper<StoreDay, StoreDayExample> {

    /**
     * 查询符合条件的分组记录数
     *
     * @param example
     * @return
     */
    Integer getStoreCount(@Param("example") StoreDayExample example);

    /**
     * 店铺统计
     *
     * @param example
     * @param startRow
     * @param size
     * @return
     */
    List<StoreBase> getStoreList(@Param("example") StoreDayExample example,
                                 @Param("startRow") Integer startRow,
                                 @Param("size") Integer size);

    /**
     * 店铺统计
     *
     * @param example
     * @return
     */
    List<StoreBase> getStoreListByExample(@Param("example") StoreDayExample example);

    /**
     * 店铺销售变化趋势
     *
     * @param example
     * @return
     */
    List<MovableGoodsVO> getStoreTrendList(@Param("example") StoreDayExample example);
}