package com.slodon.b2b2c.dao.read.video;

import com.slodon.b2b2c.core.database.BaseReadMapper;
import com.slodon.b2b2c.video.example.SvideoCommentExample;
import com.slodon.b2b2c.video.pojo.SvideoComment;
import com.slodon.b2b2c.vo.video.VideoMessageVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 短视频评论表readDao
 */
public interface SvideoCommentReadMapper extends BaseReadMapper<SvideoComment, SvideoCommentExample> {

    /**
     * 查看评论或回复数量
     *
     * @param example
     * @return
     */
    Integer getMessageCount(@Param("example") SvideoCommentExample example);

    /**
     * 查看评论或回复
     *
     * @param example
     * @param startRow
     * @param size
     * @return
     */
    List<VideoMessageVO> getMessageList(@Param("example") SvideoCommentExample example,
                                        @Param("startRow") Integer startRow,
                                        @Param("size") Integer size);
}