package com.slodon.b2b2c.enums;

/**
 * 统计常量
 */
public class StatsConstant {
    /**
     * 行为类型，gpv-商品浏览，cart-加入购物车，buy-购买，fav-商品收藏，spv-店铺浏览，reg-会员注册，pv-网站浏览，fol-店铺关注
     */
    public static final String GOODS_PAGE_VIEW = "gpv";
    public static final String GOODS_TO_CART = "cart";
    public static final String GOODS_BUY = "buy";
    public static final String GOODS_FAVORITE = "fav";
    public static final String STORE_PAGE_VIEW = "spv";
    public static final String MEMBER_REGISTER = "reg";
    public static final String PAGE_VIEW = "pv";
    public static final String STORE_FOLLOW = "fol";

    /**
     * 终端名称，pc；H5；Android；IOS；xcx-微信小程序
     */
    public static final String TERMINAL_PC = "pc";
    public static final String TERMINAL_H5 = "h5";
    public static final String TERMINAL_ANDROID = "android";
    public static final String TERMINAL_IOS = "ios";
    public static final String TERMINAL_WX_XCX = "xcx";
    public static final String TERMINAL_BD_XCX = "bdxcx";
    public static final String TERMINAL_ALI_XCX = "alixcx";
    public static final String TERMINAL_DY_XCX = "dyxcx";

    /**
     * 时间类型:1-昨天;2-近7天;3-近30天
     */
    public static final int TIME_TYPE_1 = 1;
    public static final int TIME_TYPE_2 = 2;
    public static final int TIME_TYPE_3 = 3;

    /**
     * admin实时统计 redis key
     */
    public static final String ADMIN_PRESENT_REDIS_KEY = "stats_admin_present";

    /**
     * seller实时统计 redis key
     */
    public static final String SELLER_PRESENT_REDIS_KEY = "stats_seller_present";
}
