package com.slodon.b2b2c.vo.promotion;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 *
 * 封装会员抽奖信息VO对象
 * @author wuxy
 */
@Data
public class MemberDrawInfoVO {

    @ApiModelProperty("奖项id")
    private Integer prizeId;

    @ApiModelProperty("奖项名称")
    private String prizeName;

    @ApiModelProperty("奖项图片")
    private String prizeImage;

    @ApiModelProperty("未中奖图片")
    private String losePrizeImage;

    @ApiModelProperty("是否中奖，0-未中奖，1-中奖")
    private Integer isPrize;

    @ApiModelProperty("奖品类型，1-积分，2-优惠券，中奖必填")
    private Integer prizeType;

    @ApiModelProperty("奖励描述（未中奖、xx积分、xxx优惠券*n）")
    private String description;

    @ApiModelProperty("优惠券类型(1-固定金额券；2-折扣券（折扣比例）；3-随机金额券）")
    private Integer couponType;

    @ApiModelProperty("优惠券类型对应的具体值(满减金额:例如20元，折扣：例如90为90%）")
    private BigDecimal publishValue;

    @ApiModelProperty("随机金额的最大值")
    private BigDecimal randomMax;

    @ApiModelProperty("随机金额最小值")
    private BigDecimal randomMin;

    @ApiModelProperty("使用起始时间")
    private Date effectiveStart;

    @ApiModelProperty("使用结束时间")
    private Date effectiveEnd;
}
