package com.slodon.b2b2c.vo.seller;

import com.slodon.b2b2c.core.constant.StoreOpenAccountConst;
import com.slodon.b2b2c.seller.pojo.StoreWithdrawal;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 商户提现记录vo
 */
@Data
@NoArgsConstructor
public class StoreWithdrawalListVO implements Serializable {
    private static final long serialVersionUID = 7474135223597947517L;

    public StoreWithdrawalListVO(StoreWithdrawal storeWithdrawal) {
        BeanUtils.copyProperties(storeWithdrawal,this);
        switch (storeWithdrawal.getState()){
            case StoreOpenAccountConst.WITHDRAWAL_STATE_10:
                this.stateValue = "提现中";
            break;
            case StoreOpenAccountConst.WITHDRAWAL_STATE_20:
                this.stateValue = "提现成功";
                break;
            case StoreOpenAccountConst.WITHDRAWAL_STATE_21:
                this.stateValue = "提现失败";
                break;
        }
    }


    @ApiModelProperty("提现id")
    private Integer withdrawalId;

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("管理员id")
    private Long vendorId;

    @ApiModelProperty("提现单号")
    private String withdrawalSn;

    @ApiModelProperty("提现金额")
    private BigDecimal amount;

    @ApiModelProperty("绑卡-账户名称")
    private String bankAccountName;

    @ApiModelProperty("绑卡-账户号码")
    private String bankAccountNumber;

    @ApiModelProperty("绑卡-银行id，对应中金附录")
    private String bankId;

    @ApiModelProperty("绑卡-银行名称，对应中金附录")
    private String bankName;

    @ApiModelProperty("绑卡-企业-分支行名称")
    private String branchName;

    @ApiModelProperty("提现申请时间")
    private Date createTime;

    @ApiModelProperty("提现处理时间")
    private Date dealTime;

    @ApiModelProperty("状态，10-提现审核中，20提现成功待打款，21-提现失败")
    private Integer state;

    @ApiModelProperty("状态，10-提现审核中，20提现成功待打款，21-提现失败")
    private String stateValue;

    @ApiModelProperty("失败原因")
    private String failReason;
}