package com.slodon.b2b2c.vo.seller;

import com.slodon.b2b2c.seller.pojo.StoreOpenAccount;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 商户中金账户信息vo
 */
@Data
@NoArgsConstructor
public class StoreZjAccountInfoVO implements Serializable {
    private static final long serialVersionUID = 7474135223597947517L;

    public StoreZjAccountInfoVO(StoreOpenAccount storeOpenAccount) {
        this.bankAccountName = storeOpenAccount.getBankAccountName();
        this.bankAccountNumber = storeOpenAccount.getBankAccountNumber();
        this.bankId = storeOpenAccount.getBankId();
        this.bankName = storeOpenAccount.getBankName();
        this.branchName = storeOpenAccount.getBranchName();
    }


    @ApiModelProperty("绑卡-账户名称")
    private String bankAccountName;

    @ApiModelProperty("绑卡-账户号码")
    private String bankAccountNumber;

    @ApiModelProperty("绑卡-银行id，对应中金附录")
    private String bankId;

    @ApiModelProperty("绑卡-银行名称，对应中金附录")
    private String bankName;

    @ApiModelProperty("绑卡-企业-分支行名称")
    private String branchName;

    @ApiModelProperty("账户余额")
    private BigDecimal balance;
}