package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * 封装概况-品牌销售占比Vo对象
 * @author wuxy
 */
@Data
public class BrandPercentVO {

    @ApiModelProperty("销售额列表")
    private List<SaleAmountVO> saleAmountList = new ArrayList<>();

    @ApiModelProperty("销量列表")
    private List<SaleNumVO> saleNumList = new ArrayList<>();

    @Data
    public static class SaleAmountVO {
        @ApiModelProperty("品牌名称")
        private String brandName;

        @ApiModelProperty("销售额")
        private BigDecimal saleAmount;

        @ApiModelProperty("销售额占比")
        private String saleAmountPercent;

    }

    @Data
    public static class SaleNumVO {
        @ApiModelProperty("品牌名称")
        private String brandName;

        @ApiModelProperty("销量")
        private Integer saleNum;

        @ApiModelProperty("销量占比")
        private String saleNumPercent;

    }
}
