package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 *
 * 封装商品动销-商品动销趋势Vo对象
 * @author wuxy
 */
@NoArgsConstructor
@Data
public class MovableGoodsVO {

    @ApiModelProperty("统计时间")
    private String statsTime;

    @ApiModelProperty("新增商品数")
    private Integer newGoodsNum;

    @ApiModelProperty("动销商品数")
    private Integer movableGoodsNum;

    @ApiModelProperty("下单数")
    private Integer orderSubmitNum;

    @ApiModelProperty("支付订单数")
    private Integer orderPayNum;

    @ApiModelProperty("新增会员数")
    private Integer newMemberNum;

    @ApiModelProperty("新增店铺数")
    private Integer newStoreNum;

    @ApiModelProperty("支付金额")
    private BigDecimal orderPayAmount;

    @ApiModelProperty("下单金额")
    private BigDecimal orderSubmitAmount;

    @ApiModelProperty("访客数")
    private Integer visitorNum;

    @ApiModelProperty("访问量")
    private Integer viewNum;

    @ApiModelProperty("下单人数")
    private Integer orderSubmitMemberNum;

    @ApiModelProperty("支付人数")
    private Integer orderPayMemberNum;

    @ApiModelProperty("支付订单客单价，支付订单金额/支付订单人数")
    private BigDecimal orderPayAtv;

    @ApiModelProperty("店铺关注数")
    private Integer collectionStoreNum;

}
