package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * 封装概况-支付或下单金额趋势Vo对象
 * @author wuxy
 */
@Data
public class PlatformSalesVO {

    @ApiModelProperty("支付金额列表")
    private List<PayAmountVO> payAmountList = new ArrayList<>();

    @ApiModelProperty("下单金额列表")
    private List<OrderAmountVO> orderAmountList = new ArrayList<>();

    @Data
    public static class PayAmountVO {
        @ApiModelProperty("统计时间")
        private String statsTime;

        @ApiModelProperty("支付金额")
        private BigDecimal orderPayAmount;
    }

    @Data
    public static class OrderAmountVO {
        @ApiModelProperty("统计时间")
        private String statsTime;

        @ApiModelProperty("下单金额")
        private BigDecimal orderSubmitAmount;
    }

}
