package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * 封装交易分析-销售占比Vo对象
 * @author wuxy
 */
@Data
public class SalesPercentVO {

    @ApiModelProperty("销售额(支付金额)列表")
    private List<OrderPayAmountVO> orderAmountList = new ArrayList<>();

    @ApiModelProperty("订单量列表")
    private List<OrderNumVO> orderNumList = new ArrayList<>();

    @Data
    public static class OrderPayAmountVO {
        @ApiModelProperty("省份名称")
        private String provinceName;

        @ApiModelProperty("终端名称，1、pc；2、H5；3、Android；4、IOS；5、微信小程序")
        private String terminalName;

        @ApiModelProperty("销售额(支付金额)")
        private BigDecimal orderPayAmount;

        @ApiModelProperty("销售额(支付金额)占比")
        private String orderAmountPercent;

    }

    @Data
    public static class OrderNumVO {
        @ApiModelProperty("省份名称")
        private String provinceName;

        @ApiModelProperty("终端名称，1、pc；2、H5；3、Android；4、IOS；5、微信小程序")
        private String terminalName;

        @ApiModelProperty("订单量")
        private Integer orderPayNum;

        @ApiModelProperty("订单量占比")
        private String orderNumPercent;

    }
}
