package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * seller首页概况实时统计vo
 */
@Data
public class SellerPresentIndexVO {
    @ApiModelProperty("更新时间")
    private Date statsTime;

    @ApiModelProperty("商户汇总数据（统计至更新时间）")
    private SellerPresentDataVO.SellerSummary sellerSummary;

    @ApiModelProperty("今日实时数据（今日0时至更新时间）")
    private SellerPresentDataVO.SellerTodaySummary sellerTodaySummary;

    @ApiModelProperty("待办事项（统计至更新时间）")
    private SellerWaitDeal sellerWaitDeal;


    /**
     * 待办事项
     */
    @Data
    public static class SellerWaitDeal {
        @ApiModelProperty("待发货订单数")
        private Integer deliverOrderNum;

        @ApiModelProperty("正在进行的售后单数")
        private Integer orderReturnNum;

        @ApiModelProperty("违规商品数")
        private Integer sysLowerGoodsNum;

        @ApiModelProperty("待确认结算单数")
        private Integer confirmBillNum;

        @ApiModelProperty("询盘总数")
        private Integer enquiryTotalNum;

        @ApiModelProperty("新增询盘数")
        private Integer enquiryNewNum;

        @ApiModelProperty("有效询盘数")
        private Integer validInquiryNum;

        @ApiModelProperty("待分配询盘数")
        private Integer enquiryToBeAssignNum;
    }

}
