package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 *
 * 封装交易分析-店铺排行Vo对象
 * @author wuxy
 */
@Data
public class StoreRankVO {

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("店铺名称")
    private String storeName;

    @ApiModelProperty("订单量")
    private Integer orderPayNum;

    @ApiModelProperty("销售额")
    private BigDecimal orderPayAmount;

    @ApiModelProperty("浏览量")
    private Integer viewNum;

    @ApiModelProperty("访客数")
    private Integer visitorNum;

    /**
     * 店铺销售排行
     *
     * @param storeId
     * @param storeName
     * @param orderPayNum
     * @param orderPayAmount
     */
    public StoreRankVO(Long storeId, String storeName, Integer orderPayNum, BigDecimal orderPayAmount) {
        this.storeId = storeId;
        this.storeName = storeName;
        this.orderPayNum = orderPayNum;
        this.orderPayAmount = orderPayAmount;
    }

    /**
     * 店铺流量排行
     *
     * @param storeId
     * @param storeName
     * @param viewNum
     * @param visitorNum
     */
    public StoreRankVO(Long storeId, String storeName, Integer viewNum, Integer visitorNum) {
        this.storeId = storeId;
        this.storeName = storeName;
        this.viewNum = viewNum;
        this.visitorNum = visitorNum;
    }
}
