package com.slodon.b2b2c.vo.statistics;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * 封装交易分析-各终端销售Vo对象
 * @author wuxy
 */
@Data
public class TerminalSalesVO implements Comparable<TerminalSalesVO> {

    @ApiModelProperty("统计时间")
    private String statsTime;

    @ApiModelProperty("终端列表")
    private List<TerminalVO> terminalList = new ArrayList<>();

    @Override
    public int compareTo(TerminalSalesVO o) {
        return this.statsTime.compareTo(o.getStatsTime());
    }

    @Data
    public static class TerminalVO {

        @ApiModelProperty("终端名称，1、pc；2、H5；3、Android；4、IOS；5、微信小程序")
        private String terminalName;

        @ApiModelProperty("销售额")
        private BigDecimal orderPayAmount;

        @ApiModelProperty("订单量")
        private Integer orderPayNum;

        @ApiModelProperty("新增会员数")
        private Integer newMemberNum;

        @ApiModelProperty("储值会员数")
        private Integer rechargeMemberNum;

        @ApiModelProperty("下单人数")
        private Integer orderSubmitMemberNum;

        @ApiModelProperty("支付人数")
        private Integer orderPayMemberNum;
    }

}
