package com.slodon.b2b2c.vo.system;

import com.slodon.b2b2c.system.pojo.Express;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * 封装物流公司VO对象
 *
 * @author wuxy
 */
@Data
public class ExpressVO implements Serializable {

    private static final long serialVersionUID = 1602217049353247103L;
    @ApiModelProperty("物流ID")
    private Integer expressId;

    @ApiModelProperty("物流名称")
    private String expressName;

    @ApiModelProperty("物流编号")
    private String expressCode;

    @ApiModelProperty("是否支持电子面单：1-是; 0-否")
    private Integer isSupportFaceSheet;

    public ExpressVO(Express express) {
        expressId = express.getExpressId();
        expressName = express.getExpressName();
        expressCode = express.getExpressCode();
    }
}
