package com.slodon.b2b2c.vo.video;

import com.slodon.b2b2c.core.i18n.Language;
import com.slodon.b2b2c.core.util.CommonUtil;
import com.slodon.b2b2c.video.pojo.LiveStoreBindMember;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 *
 * 封装店铺绑定会员VO对象
 * @author wuxy
 */
@Data
public class LiveStoreBindMemberVO implements Serializable {

    private static final long serialVersionUID = 2800411021533426651L;
    @ApiModelProperty("绑定id")
    private Integer bindId;

    @ApiModelProperty("会员id")
    private Integer memberId;

    @ApiModelProperty("会员名称")
    private String memberName;

    @ApiModelProperty("会员昵称")
    private String memberNickName;

    @ApiModelProperty("会员手机号")
    private String memberMobile;

    @ApiModelProperty("会员状态：0-禁用，1-启用")
    private Integer memberState;

    @ApiModelProperty("会员状态：0-禁用，1-启用")
    private String memberStateValue;

    @ApiModelProperty("短视频状态：2-正常，4-禁止")
    private Integer svideoState;

    @ApiModelProperty("短视频状态：2-正常，4-禁止")
    private String svideoStateValue;

    @ApiModelProperty("直播状态：1-正常；0-禁止")
    private Integer LiveState;

    @ApiModelProperty("直播状态：1-正常；0-禁止")
    private String LiveStateValue;

    public LiveStoreBindMemberVO(LiveStoreBindMember liveStoreBindMember, Integer memberState, Integer svideoState, Integer liveState) {
        this.bindId = liveStoreBindMember.getBindId();
        this.memberId = liveStoreBindMember.getMemberId();
        this.memberName = liveStoreBindMember.getMemberName();
        this.memberNickName = liveStoreBindMember.getMemberNickName();
        this.memberMobile = CommonUtil.dealMobile(liveStoreBindMember.getMemberMobile());
        this.memberState = memberState;
        this.memberStateValue = Language.translate(memberState == 1 ? "正常" : "禁止");
        this.svideoState = svideoState;
        this.svideoStateValue = Language.translate(svideoState == 2 ? "正常" : "禁止");
        this.LiveState = liveState;
        this.LiveStateValue = Language.translate(liveState == 1 ? "正常" : "禁止");
    }
}
