package com.slodon.b2b2c.vo.video;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * 封装查看评论或回复vo对象
 * @author wuxy
 */
@Data
public class VideoMessageVO implements Serializable {

    private static final long serialVersionUID = 2292588723049503100L;
    @ApiModelProperty("回复id")
    private Integer replyId;

    @ApiModelProperty("评论id")
    private Integer commentId;

    @ApiModelProperty("作者id")
    private Integer authorId;

    @ApiModelProperty("作者名称")
    private String authorName;

    @ApiModelProperty("作者头像")
    private String memberAvatar;

    @ApiModelProperty("视频id")
    private Integer videoId;

    @ApiModelProperty("封面图地址")
    private String videoImage;

    @ApiModelProperty("是否已读：0未读，1已读")
    private Integer isRead;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("内容")
    private String content;

    @ApiModelProperty("消息类型")
    private String msgType;

    @ApiModelProperty("视频类型:1-视频;2-图文")
    private Integer videoType;
}
