import { createGtm } from '@gtm-support/vue-gtm';


export default defineNuxtPlugin((nuxtApp) => {
    nuxtApp.vueApp.use(createGtm({
        id:'GTM-NDZKZBH',
        // queryParams: {
        //     // 使用 GTM ID 加载 gtm.js 时添加 URL 查询字符串（使用自定义环境时需要）
        //     gtm_auth: 'AB7cDEf3GHIjkl-MnOP8qr',
        //     gtm_preview: 'env-4',
        //     gtm_cookies_win: 'x',
        // },
        defer: false, //可以将脚本设置为“延迟”以加快页面加载速度，但代价是结果不准确（以防访问者在脚本加载前离开，这种情况不太可能但有可能发生）。默认为 false，因此脚本默认加载为 `async`
        compatibility: false, //将在脚本标签中添加 `async` 和 `defer` 以不阻止不支持 `async` 的旧浏览器的请求
       //nonce: '2726c7f26c', // 会将 `nonce` 添加到脚本标签
        enabled: false, // 默认为真。可以通过将此设置为 false 来禁用插件，例如：已启用：!!GDPR_Cookie（可选）
        debug: true, // 是否显示控制台日志调试（可选）
        loadScript: true, // 是否加载 GTM 脚本（如果您手动包含 GTM 很有帮助，但需要组件中的数据层功能）（可选）
        vueRouter: useRouter(), // 传递路由器实例以自动与路由器同步（可选）
       // ignoredViews: ['homepage'], //不触发指定路由器名称的事件（可选）
        trackOnNextTick: false, // Vue.nextTick 中是否调用trackView
    }))
})
